﻿using System;
using System.Collections.Generic;
using System.Linq;
using Syncfusion.JavaScript;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using System.ComponentModel.DataAnnotations;
using System.Collections;
using Syncfusion.JavaScript.DataSources;
using WebApplication8.Models;
using WebApplication8.DAL;

namespace WebApplication8.Controllers
{
    public class HomeController : Controller
    {
        private ClientRepository clientRepository = null;


        public IActionResult Index()
        {
            clientRepository = new ClientRepository();
            var clients = clientRepository.GetAll().ToList();
            ViewBag.DataSource = clients;
            return View();
        }

        public ActionResult GetDetailData([FromBody]DataManager value )
        {
            // TODO: Retrieve detail data for the currently selected client.
          //  IEnumerable Data = null;
            clientRepository = new ClientRepository();
            IEnumerable Data = clientRepository.GetAll().ToList();
            DataOperations dp = new DataOperations();
            if (value.Where != null)
            {
                Data = dp.PerformWhereFilter(Data, value.Where, value.Where[0].Condition);
            }
            return Json(new { result = Data });
        }

        #region Client grid methods
        public ActionResult InsertClient([FromBody]CRUDModel<ClientModel> obj)
        {
            clientRepository.Add(obj.Value);
            return Json(obj.Value);
        }

        public ActionResult UpdateClient([FromBody]CRUDModel<ClientModel> obj)
        {
            clientRepository.Update(obj.Value._id, obj.Value);
            return Json(obj.Value);
        }

        public ActionResult DeleteClient([FromBody]CRUDModel<ClientModel> obj)
        {
            clientRepository.Delete(obj.Key.ToString());
            return Json(obj);
        }
        #endregion

        #region Date grid methods
        public ActionResult InsertDate([FromBody]CRUDModel<ClientModel> obj)
        {
            // Add important clientRepository.AddImportantDate(obj.Value);
            return Json(obj.Value);
        }

        public ActionResult UpdateDate([FromBody]CRUDModel<ClientModel> obj)
        {
            clientRepository.Update(obj.Value._id, obj.Value);
            return Json(obj.Value);
        }

        public ActionResult DeleteDate([FromBody]CRUDModel<ClientModel> obj)
        {
            clientRepository.Delete(obj.Key.ToString());
            return Json(obj);
        }
        #endregion
    }
}
